#coding: utf-8


class MockRequest(object):
    u'''
    Ранее записанный запрос к HTTP-серверу.

    :param verb: HTTP-метод, используемый при отправке ответа (GET/POST/PUT/DELETE/HEAD)
    :param uri: URI, по которому будет отправлен запрос
    :param body: Тело запроса
    :param cookies: Набор cookie-маркеров
    :type cookies: dict
    :param headers: Заголовки отправляемого HTTP-запроса.
    :type headers: dict
    '''

    def __init__(self, verb, uri, body=None, cookies=None, headers=None):
        assert verb in ['GET', 'POST', 'PUT', 'DELETE', 'HEAD'], 'Unsupported HTTP verb'

        self.verb = verb
        self.uri = uri
        self.body = body or ''
        self.cookies = cookies or {}
        self.headers = headers or {}
        self.auth = dict(username=None, password=None)

    def __repr__(self):
        return u'<{0} {1} HTTP/1.1 ({2} bytes)>'.format(self.verb, self.uri, len(self.body))
